#include "grille.h"
#include <Imagine/Graphics.h>
#include <string>
using namespace Imagine;
using namespace std;

/// Marge pour affichage de valeur
const int marge=taille/3;

// Declaration pour pouvoir etre utilisee dans Q4 alors que sa definition vient
// en Q5
bool verifie_case(Grille g, int i0, int j0);

/// Question 1
void init_grille(Grille& g) {
    for(int i=0; i<9; i++)
        for(int j=0; j<9; j++) {
            g.valeur[i][j] = 0;
            g.indice[i][j] = false;
        }
            
}

/// Question 2 (1/2)
void affiche_lignes() {
    for(int i=1; i<=8; i++) { // Lignes horizontales
        int epaisseur = 1;
        if(i%3 == 0) // Nouveau bloc
            epaisseur = 3;
        drawLine(0, i*taille, 9*taille, i*taille, BLACK, epaisseur);
    }
    for(int j=1; j<=8; j++) { // Lignes verticales
        int epaisseur = 1;
        if(j%3 == 0) // Nouveau bloc
            epaisseur = 3;
        drawLine(j*taille, 0, j*taille, 9*taille, BLACK, epaisseur);
    }
}

/// Question 2 (2/2)
void affiche_grille(Grille g) {
    clearWindow();
    affiche_lignes();
    for(int i=0; i<9; i++)
        for(int j=0; j<9; j++)
            if(g.valeur[i][j] != 0) {
                Color col = BLACK;
                if(g.indice[i][j])
                    col = RED;
                string s="X";
                s[0] = '0' + g.valeur[i][j];
                drawString(j*taille+marge, (i+1)*taille-marge, s, col);
            }
}

/// Question 3
bool entre_case(int& i, int& j, int& val) {
    int x, y;
    if(getMouse(x,y) == 3)
        return false;
    i = y / taille;
    j = x / taille;
    fillRect(j*taille, i*taille, taille, taille, GREEN);
    do { // Loop until valid value
        val = getKey();
        if('0'<=val && val<='9') {
            val -= '0';
            return true;
        }
    } while (true);
}

/// Question 4
Grille entre_grille() {
    Grille g;
    init_grille(g);
    affiche_grille(g);
    int i, j, val;
    while(entre_case(i,j,val)) {
        Grille avant = g;
        g.valeur[i][j] = val;
        g.indice[i][j] = true;
        if(! verifie_case(g,i,j)) { // Question 6
            g = avant;
            fillRect(j*taille, i*taille, taille, taille, RED);
            milliSleep(1000);
        }
        affiche_grille(g);
    }
    return g;
}

/// Question 5
bool verifie_case(Grille g, int i0, int j0) {
    for(int i=0; i<9; i++) { // Colonne
        if(i!=i0 && g.valeur[i0][j0] == g.valeur[i][j0])
            return false;
    }
    for(int j=0; j<9; j++) { // Ligne
        if(j!=j0 && g.valeur[i0][j0] == g.valeur[i0][j])
            return false;
    }
    int di=(i0/3)*3, dj=(j0/3)*3; // Bloc
    for(int i=di; i<di+3; i++)
        for(int j=dj; j<dj+3; j++)
            if((i!=i0 || j!=j0) && g.valeur[i0][j0] == g.valeur[i][j])
                return false;
    return true;
}

/// Question 7
bool case_suivante(Grille g, int& i, int& j) {
    while(i<9 && j<9) {
        ++ j;
        if(j==9) {
            j=-1;
            ++i;
        } else if(! g.indice[i][j])
            return true;
    }
    return false;
}

/// Question 8
bool resous_grille(Grille& g, int i0, int j0) {
    for(int v=1; v<=9; v++) {
        g.valeur[i0][j0] = v;
        if(verifie_case(g,i0,j0)) {
            int i=i0, j=j0;
            if(!case_suivante(g,i,j) || resous_grille(g,i,j))
                return true;
        }
    }
    g.valeur[i0][j0] = 0;
    return false;
}

/// Question 9
bool resous_grille(Grille& g) {
    int i=0, j=-1;
    if(! case_suivante(g, i,j))
        return true;
    return resous_grille(g, i, j);
}
